; Simulador del TMS320C3x v2.1 - Proyecto de Fin de Carrera
; Ingenieria Tecnica de Telecomunicacin
; Rubn Alonso Alejandre - Joaqun Cubillo Arribas

; Ejemplo 1.- Bucles y saltos a subrutina

;*** CODIGO ***************************************************************************
        .start "CODE", 0x809802         ;Punto de incio del cdigo
        .sect "CODE"
        .entry SAMPLE                   ;Punto entrada a debugger

SAMPLE          LDP @stack              ;Inicializa el puntero de pgina
                LDI @stack, SP          ;Inicializa el puntero de pila

                LDI 0, R0               ;Comienza con SEED = 0
                LDI 0, R1               ;Inicializa contador lazo INNER
                LDI 0, R2               ;Inicializa contador lazo OUTER

OUTER           LDI 3, RC               ;Comienza lazo <OUTER>
                RPTB INNER              ;Bloque de repeticin <INNER> de (RC+1)
                CALL RANDX              ;LLamada a subrutina <RANCX>
INNER           ADDI 1, R1              ;Contador de lazo <INNER>
                ADDI 1, R2              ;Contador de lazo <OUTER>
                b OUTER                 ;Salto a <OUTER>

;*** Generador de nmeros aleatoriis de 32 bits ***
RANDX:          LDI @SEED, R0           ;Recupera ek ltimo valor de <SEED>
                MPYI @A, R0             ;Calcula RAND(R0)
                ADDI @C, R0
                STI  R0, @SEED          ;Almacena Resultado
                RETS                    ;Retorno de Subrutina

;*** DATOS ***************************************************************************
        .start "DATA", 0x809C00
        .sect "DATA"
A       .word 0107456h                  ;Constante para RAND
C       .word 0234567h
SEED    .word 0

;*** Zona de Pila ***
stack   .word $+1                       ;Pila
        .end